; ***********************************************
; *                                             *
; * Twirled Minds by Laze 'Cybernator' Ristoski *
; *                                             *
; ***********************************************
; Assemble with ACME

		!to "twirl.prg"             
                *= $0801

                ; SYS 2064
                !raw $0b,$08,$d3,$07,$9e,$32,$30,$36,$34
                !raw $00,$00,$00,$00,$00,$00

speedcode       = $2700
initmusic       = $1000
playmusic       = $1003
xsin            = $2000
ysin            = $2100
twirlsin        = $2178

a               = $af
x               = $ae
y               = $ad
restore_flag    = $ac
upperbar        = $ab
lowerbar        = $aa
barcolor        = $a9
inbetween       = $a8
fadeptr         = $a7
xpos            = $a6
ypos            = $a5
fadeaway1       = $a4           ; Pointers to the luma table
fadeaway2       = $a3
fadeaway3       = $a2
temp            = $a1
tempypos        = $a0
xpos_ptr        = $9f
ypos_ptr        = $9e
twirl_ptr       = $9d
times           = $9c

irq1_1_r        = $ff
irq2_1_r        = $fb
irq2_2_r        = $2d

                sei
                ldx #255
                txs
                lda #$35
                sta $01
                lda #$7f
                sta $dc0d
                sta $dd0d
                lda $dc0d
                lda $dd0d
                lda #1
                sta $d01a

                ldx #0
                lda #0
clearbitmap     sta $a000,x
                sta $a100,x
                sta $a200,x
                sta $a300,x
                sta $a400,x
                sta $a500,x
                sta $a600,x
                sta $a700,x
                sta $a800,x
                sta $a900,x
                sta $aa00,x
                sta $ab00,x
                sta $ac00,x
                sta $ad00,x
                sta $ae00,x
                sta $af00,x
                sta $b000,x
                sta $b100,x
                sta $b200,x
                sta $b300,x
                sta $b400,x
                sta $b500,x
                sta $b600,x
                sta $b700,x
                sta $b800,x
                sta $b900,x
                sta $ba00,x
                sta $bb00,x
                sta $bc00,x
                sta $bd00,x
                sta $be00,x
                sta $bf00,x
                inx
                bne clearbitmap

                lda #0
                jsr setcolor

                ldx #2
                lda #4
                sta $00,x
                inx
                bne *-3

                lda #0
                sta $d020
                sta $d021
                sta $d015
                lda #$95
                sta $dd00
                lda #0
                sta $d011
                lda #$d8
                sta $d016
                lda #$08
                sta $d018

                lda #0
                jsr initmusic

                lda #<nmi
                ldx #>nmi
                sta $fffa
                stx $fffb
                lda #0
                sta restore_flag
                sta $dd04
                lda #1
                sta $dd05
                lda #$81
                sta $dd0d
                lda #$11
                sta $dd0e

                lda restore_flag
                beq *-2

                ldx #150
                stx upperbar
                inx
                stx lowerbar

                lda #0
                sta barcolor
                sta temp
                lda #7
                sta inbetween

                lda #<irq1_1
                ldx #>irq1_1
                sta $fffe
                stx $ffff
                lda #irq1_1_r
                sta $d012
                cli

                ldx #0
                ldy #0
                dey
                bne *-1
                dex
                bne *-4

fadebar         lda #0
                cmp $d012
                bne *-3
                lda $d011
                bmi *-10
                inc temp
                ldx temp
                lda luma,x
                sta barcolor
                lda #1		; Used to skip a frame
		cmp $d012
		bne *-3
                lda $d011
		bmi *-10
                cpx #15
                bne fadebar

                lda #13
                sta fadeptr

                lda #9
                ldx #0
                ldy #0
                dey
                bne *-1
                dex
                bne *-4
                sec
                sbc #1
                bne *-9

barsloop        lda #0
                cmp $d012
                bne *-3
                lda upperbar
                cmp #$31
                beq nextpart
                cmp #$4a
                bcs nofade
                ldx fadeptr
                lda luma,x
                sta inbetween
                cpx #0
                beq *+4
                dec fadeptr
nofade          dec upperbar
                inc lowerbar
                sec
                lda upperbar
                sbc #1
                sta $d012
                lda #1
                cmp $d012
                bne *-3
                jmp barsloop

nextpart        jmp twirl

irq1_1          sta a
                stx x
                sty y
                jsr playmusic
                lda #<irq1_2
                ldx #>irq1_2
                sta $fffe
                stx $ffff
                sec
                lda upperbar
                sbc #1
                sta $d012
                dec $d019
                lda a
                ldx x
                ldy y
                rti

irq1_2          sta a
                stx x
                ldx #9
                dex
                bne *-1
                nop
                nop
                lda barcolor
                sta $d020
                clc
                lda lowerbar
                sbc upperbar
                beq noemptyspace
                ldx #9
                dex
                bne *-1
                ldx inbetween
                stx $d020
                cmp #1
                beq oneemptyspace
                sec
                lda lowerbar
                sbc #1
                sta $d012
                lda #<irq1_3
                ldx #>irq1_3
                sta $fffe
                stx $ffff
                dec $d019
                lda a
                ldx x
                rti

noemptyspace    ldx #9
                dex
                bne *-1
                lda #0
                sta $d020
                lda #<irq1_1
                ldx #>irq1_1
                sta $fffe
                stx $ffff
                lda #irq1_1_r
                sta $d012
                dec $d019
                lda a
                ldx x
                rti

oneemptyspace   ldx #8
                dex
                bne *-1
                nop
                lda barcolor
                sta $d020
                ldx #12
                dex
                bne *-1
                lda #0
                sta $d020
                lda #<irq1_1
                ldx #>irq1_1
                sta $fffe
                stx $ffff
                lda #irq1_1_r
                sta $d012
                dec $d019
                lda a
                ldx x
                rti
                
irq1_3          sta a
                stx x
                ldx #9
                dex
                bne *-1
                nop
                nop
                lda barcolor
                sta $d020
                ldx #11
                dex
                bne *-1
                lda #0
                sta $d020
                lda #<irq1_1
                ldx #>irq1_1
                sta $fffe
                stx $ffff
                lda #irq1_1_r
                sta $d012
                dec $d019
                lda a
                ldx x
                rti

nmi             lda #1
                sta restore_flag
                lda #$7f
                sta $dd0d
                rti

twirl           jsr speedcode
                lda #$90
                cmp $d012
                bne *-3
                lda #<irq2_1
                ldx #>irq2_1
                sta $fffe
                stx $ffff
                lda #irq2_1_r
                sta $d012
                lda #$3b
                sta $d011
                lda #108
                ldx #45 
                sta xpos                               
                stx ypos
                lda #$40
                ldx #$1e
                sta xpos_ptr
                stx ypos_ptr

                ldx #0
fadein          lda #$c0
                cmp $d012
                bne *-3
                lda luma,x
                asl
                asl
                asl
                asl
                ora luma,x
                jsr setcolor
                inx
                cpx #16
                bne fadein

                ldx #15
                stx fadeaway1
                stx fadeaway2
                stx fadeaway3

fadeaway_loop   lda fadeaway1
                cmp #8
                beq *+4
                dec fadeaway1
                lda fadeaway2
                cmp #1
                beq *+4
                dec fadeaway2
                lda fadeaway3
                cmp #5
                beq *+4
                dec fadeaway3

                lda #$c0
                cmp $d012
                bne *-3
                ldy fadeaway1
                lda luma,y
                asl
                asl
                asl
                asl
                ldy fadeaway2
                ora luma,y
                jsr setcolor_scr
                ldy fadeaway3
                lda luma,y
                jsr setcolor_clr
                dex
                bpl fadeaway_loop
                jmp control
		
setcolor        ldy #39
setcolor2       sta $8050,y
                sta $8078,y
                sta $80a0,y
                sta $80c8,y
                sta $80f0,y
                sta $8118,y
                sta $8140,y
                sta $8168,y
                sta $8190,y
                sta $81b8,y
                sta $81e0,y
                sta $8208,y
                sta $8230,y
                sta $d800,y
                sta $d828,y
                sta $d850,y
                sta $d878,y
                sta $d8a0,y
                sta $d8c8,y
                sta $d8f0,y
                sta $d918,y
                sta $d940,y
                sta $d968,y
                sta $d990,y
                sta $d9b8,y
                sta $d9e0,y
                sta $da08,y
                sta $da30,y
                dey
                bpl setcolor2
                rts

setcolor_scr    ldy #39
setcolor2_scr   sta $8050,y
                sta $8078,y
                sta $80a0,y
                sta $80c8,y
                sta $80f0,y
                sta $8118,y
                sta $8140,y
                sta $8168,y
                sta $8190,y
                sta $81b8,y
                sta $81e0,y
                sta $8208,y
                sta $8230,y
                dey
                bpl setcolor2_scr
                rts

setcolor_clr    ldy #39
setcolor2_clr   sta $d850,y
                sta $d878,y
                sta $d8a0,y
                sta $d8c8,y
                sta $d8f0,y
                sta $d918,y
                sta $d940,y
                sta $d968,y
                sta $d990,y
                sta $d9b8,y
                sta $d9e0,y
                sta $da08,y
                sta $da30,y
                dey
                bpl setcolor2_clr
                rts

irq2_1          sta a
                stx x
                sty y
                ldx #9
                dex
                bne *-1
                lda barcolor
                sta $d020
                ldx #11
                dex
                bne *-1
                lda #0
                sta $d020
                lda #$3f
                sta $d011
                jsr playmusic

move_flag       jmp irq2_1_end  ; When it's time to move the picture
                ldx xpos_ptr    ; the JMP is replaced by BIT
                inx
                stx xpos_ptr
                lda xsin,x
                sta xpos

                ldx ypos_ptr
                inx
                cpx #$78
                bne *+4
                ldx #0
                stx ypos_ptr
                lda ysin,x
                sta ypos

irq2_1_end      lda #<irq2_2
                ldx #>irq2_2
                sta $fffe
                stx $ffff
                lda #irq2_2_r
                sta $d012
                dec $d019
                lda a
                ldx x
                ldy y
                rti

irq2_2          sta a
                stx x
                sty y
                lda #<irq2_2d
                ldx #>irq2_2d
                sta $fffe
                stx $ffff
                inc $d012
                dec $d019
                cli
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                jmp *-11

irq2_2d         lda $d012
                ldx #9
                dex
                bne *-1
                cmp $d012
                beq *+2

; ---
; VSP
; ---

                lda xpos
                and #7
                ora #$d8
                sta $d016
                lda xpos
                lsr
                lsr
                lsr
                sta temp
                sec
                lda #39
                sbc temp
                sta *+4
                bcs *
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                lda #$a9
                bit $ea

                ldx #4
                dex
                bne *-1
                nop
                nop
                nop

                lda #$78        ; This generates VSP
                sta $d011

                nop
                lda barcolor
                sta $d020
                ldx #11
                dex
                bne *-1
                lda #0
                sta $d020

                lda ypos
                sta tempypos
                lda #<irq2_3
                ldx #>irq2_3
                sta $fffe
                stx $ffff
                lda #$36
                sta $d012
                dec $d019
                pla
                pla
                pla
                lda a
                ldx x
                ldy y
                rti

irq2_3          sta a
                stx x
                lda $d012
                pha
                lda tempypos
                cmp #8
                bcs more_fld
                clc
                adc #1
                ora #$38
                cmp #$38
                beq rc0
                cmp #$3f
                beq rc7
                ldx #5
                dex
                bne *-1
                sta $d011
rcnot0          lda #<irq2_1
                ldx #>irq2_1
                sta $fffe
                stx $ffff
                lda #irq2_1_r
                sta $d012
                dec $d019
                pla
                lda a
                ldx x
                rti

rc0             lda #$7b
                sta $d011
                ldx #$20
                dex
                bne *-1
                lda #$38
                sta $d011
                jmp rcnot0

rc7             lda #$7b
                sta $d011
                ldx #$20
                dex
                bne *-1
                lda #$3f
                sta $d011
                jmp rcnot0

more_fld        ldx #2
                dex
                bne *-1
                lda #$7b
                sta $d011
                ldx #$20
                dex
                bne *-1
                lda #$78
                sta $d011
                pla
                clc
                adc #8
                sta $d012
                sec
                lda tempypos
                sbc #8
                sta tempypos
                dec $d019
                lda a
                ldx x
                rti

; The following part controls the flow of the demo

control         lda #3
                ldx #0
                ldy #0
                dey
                bne *-1
                dex
                bne *-4
                sec
                sbc #1
                bne *-9

                ldy #95
rot             lda #$fa
                cmp $d012
                bne *-3
                lda $02
                sec
direction2      sbc #1
                and #$7f
                ldx #2
                sta $00,x
                inx                  
                cpx #$27
                bne *-5
                jsr speedcode
                dey
                bne rot
                lda direction2+1
                eor #$fe
                sta direction2+1
                cmp #1
                bne rot-2
            
                lda #$2c
                sta move_flag

                ldx #3
rotmore         stx times
                ldy #95
rotright        lda #$fa
                cmp $d012
                bne *-3
                lda $02
                sec
direction       sbc #1
                and #$7f
                ldx #2
                sta $00,x
                inx                  
                cpx #$27
                bne *-5
                jsr speedcode
                dey
                bne rotright

                lda direction+1
                eor #$fe
                sta direction+1
                ldx times
                dex
                bpl rotmore

                lda #$5c
                sta twirl_ptr

main_loop       lda #2
                sta times
keepgoing       ldy #64
                lda $02
                sec
                sbc #1
                and #$7f
                sta $02
                jsr expand_wave
                lda #$fa
                cmp $d012
                bne *-3
                jsr speedcode
                dey
                bne *-23

                ldy #64
                lda $02
                clc
                adc #1
                and #$7f
                sta $02
                jsr expand_wave
                lda #$fa
                cmp $d012
                bne *-3
                jsr speedcode
                dey
                bne *-23

                dec times
                lda times
                bne keepgoing

                ldy #200
twirl_loop      ldx twirl_ptr
                inc twirl_ptr
                lda twirlsin,x
                sta $02
                jsr expand_wave
                lda #$fa
                cmp $d012
                bne *-3
                jsr speedcode
                dey
                bne twirl_loop

                ldy #$24
                jsr expand_wave
                lda #$fa
                cmp $d012
                bne *-3
                jsr speedcode
                dey
                bne *-14

                ldy #100
rot2            lda #$fa
                cmp $d012
                bne *-3
                lda $02
                sec
direction3      sbc #1
                and #$7f
                ldx #2
                sta $00,x
                inx                  
                cpx #$27
                bne *-5
                jsr speedcode
                dey
                bne rot2
                lda direction3+1
                eor #$fe
                sta direction3+1
                cmp #1
                bne rot2-2
                jmp main_loop

; ---------------------------------------------------------------------------

expand_wave     ldx #$23
                lda $02,x
                sta $03,x
                dex
                bpl *-5
                rts

; ---------------------------------------------------------------------------

luma            !raw 0, 6, 9, 2, 11, 4, 8, 12, 14, 5, 10, 3, 15, 7, 13, 1

; ---------------------------------------------------------------------------

; --- Pad with zeroes until address $1000 is reached

                !for i, $1000-* {
			!raw 0
                }

; --- Include music

		!bin "music.prg" ,,2

; --- Pad with zeroes until address $2000 is reached

                !for i, $2000-* {
			!raw 0
                }

; --- Include sinus tables

		!bin "sinus.prg" ,,2

; --- Pad with zeroes until address $2300 is reached

                !for i, $2300-* {
			!raw 0
                }

; --- Include textures and speedcode

		!bin "texture.prg" ,,2        
		!bin "spdcode.prg" ,,2











